#include <gtest/gtest.h>
#include "Vector3.h"

// Demonstrate some basic assertions
TEST(DummyTest, BasicAssertions) {
    // Expect two strings not to be equal.
    EXPECT_STRNE("hello", "world");
    // Expect equality.
    EXPECT_EQ(7 * 6, 42);
}

TEST(Vector, Normalize) {
    bool r;

    Vector3 v = Vector3(0, 2, 0);
    Vector3 normalized_v = Vector3::zero;

    normalized_v = v.normalized();
    r = normalized_v == Vector3(0, 1, 0);
    EXPECT_EQ(r, true);

    normalized_v = Vector3::Normalize(v);
    r = normalized_v == Vector3(0, 1, 0);
    EXPECT_EQ(r, true);
}

TEST(Vector, Magnitude) {
    Vector3 v = Vector3(1, 2, 3);
    float m = 0;

    m = v.magnitude();
    EXPECT_FLOAT_EQ(m, 3.74165738677F);

    m = Vector3::Magnitude(v);
    EXPECT_FLOAT_EQ(m, 3.74165738677F);
}

int main(int argc, char **argv) {
    :: testing::InitGoogleTest(&argc, argv);
    return RUN_ALL_TESTS();
}
